<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from transform.texi on 28 April 1999 -->

<TITLE>The TRANSFORM Library - Non-perfectly Nested Loops</TITLE>
<link href="transform_8.html" rel=Next>
<link href="transform_6.html" rel=Previous>
<link href="transform_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_6.html">previous</A>, <A HREF="transform_8.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC7" HREF="transform_toc.html#TOC7">Non-perfectly Nested Loops</A></H3>

<P>
The loops need not be perfectly nested for tiling.  The only exception
is that if the loops are non-perfectly nested and the iteration
space is non-rectangular, then coalescing must be turned off.

</P>
<P>
Any non-perfectly nested regions of the code must be guarded.  
For example, applying the parameters:

<PRE>
trip[0] = 100; trip[1] = 50;
nregions = 1;
coalesce[0] = FALSE;
first[0] = 0; first[1] = 2;
</PRE>

<P>
To the following code:

</P>

<PRE>
for (i = 0; i &#60;= N; i++) {

    statement1;
    for (j = 0; j &#60;= N; j++) {
        ...
    }
    statement2;
}
</PRE>

<P>
The resulting code is:

</P>

<PRE>
for (i_tile = 0; i_tile &#60;= N; i_tile += 100) {
    for (j_tile = 0; j_tile &#60;= N; j_tile += 50) {
        for (i = i_tile; i &#60;= min(N, i_tile + 99); i++) {

            if (j_tile == 0) {
               statement1;
            }

            for (j = max(0, j_tile); j &#60;= min(N, j_tile + 49); j++) {
                ...
            }

            if (N &#60; j_tile + 1) {
               statement2;
            }
        }
    }
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_6.html">previous</A>, <A HREF="transform_8.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
</BODY>
</HTML>
